﻿
using System;

using Foundation;
using UIKit;
using Syncfusion.SfDataGrid;
using CoreGraphics;
using System.Collections.ObjectModel;
using System.Reflection;
using System.Linq;
using System.Collections.Generic;

namespace GettingStarted
{
    public partial class GettingStartedViewController : UIViewController
	{
        SfDataGrid grid;
		ViewModel viewModel;
		public GettingStartedViewController ()
		{
            grid = new SfDataGrid();
			viewModel = new ViewModel();
			grid.AllowSorting = true;
            grid.AutoGenerateColumns = false;
            grid.ColumnSizer = ColumnSizer.Star;
			grid.ItemsSource = viewModel.DynamicCollection;
			grid.GridTapped += Grid_GridTapped;
			grid.GridLoaded += (sender, e) => { grid.View.LiveDataUpdateMode = Syncfusion.Data.LiveDataUpdateMode.AllowDataShaping; };
            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Order ID",
                MappingName = "Values[orderID]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
                Format="C"
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Customer ID",
                MappingName = "Values[customerID]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "First Name",
                MappingName = "Values[firstName]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "Last Name",
                MappingName = "Values[lastName]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            grid.Columns.Add(new GridTextColumn()
            {
                HeaderText = "City",
                MappingName = "Values[city]",
                LineBreakMode = UILineBreakMode.WordWrap,
                TextAlignment = UITextAlignment.Left,
                HeaderTextAlignment = UITextAlignment.Center,
            });

            //Dummy column need to be added since we have internally checked grouping column against grid column collection.
            grid.Columns.Add(new GridTextColumn()
			{
				HeaderText = "GroupProperty",
				MappingName = "GroupProperty",
				Width = 0
			});
            //Need to refresh the GroupProperty of DynamicModel in the given collection before applying groupdescription to the grid.
            viewModel.RefreshGroup("firstName");
            grid.CellRenderers.Remove("TextView");
            grid.CellRenderers.Add("TextView", new CustomCell());
            grid.GroupColumnDescriptions.Add(new GroupColumnDescription() { ColumnName = "GroupProperty" });
            this.View.Add(grid);
            
        }
		     

        public override void ViewDidLayoutSubviews()
        {
            base.ViewDidLayoutSubviews();
            this.grid.Frame = new CGRect(0, 20, View.Frame.Width, View.Frame.Height);
        }

		void Grid_GridTapped(object sender, GridTappedEventsArgs e)
		{
			viewModel.RefreshGroup("lastName");
		}
	}
}

